@using LSerialObserver.Domain.Connection
@using System.IO.Ports

<EditForm EditContext="@_editContext">
  <div class="row g-2">
    <div class="col-12">
      <label class="form-label fw-bold">Device</label>
      <div class="input-group">

        @if (_devices == null)
        {
          <input type="text" placeholder="Loading..." class="form-select" disabled/>
          <button class="btn btn-secondary" type="button" disabled>
            <span class="spinner-border spinner-border-sm" role="status"></span>
          </button>
        }
        else
        {
          <InputSelect @bind-Value="_options.Device" class="form-select">
            <option value="@string.Empty">--- Select... ---</option>
            @foreach (var device in _devices ?? Enumerable.Empty<string>())
            {
              <option value="@device">@device</option>
            }
          </InputSelect>
          <button
            @onclick="LoadAvailableDevices" class="btn btn-secondary" type="button">
            <i class="bi bi-arrow-clockwise"></i>
          </button>
        }
      </div>
    </div>

    <div class="col-3">
      <label class="form-label fw-bold">Baud rate</label>
      <InputSelect @bind-Value="_options.BaudRate" class="form-select">
        <option value="1200">1200</option>
        <option value="2400">2400</option>
        <option value="4800">4800</option>
        <option value="9600">9600</option>
        <option value="19200">19200</option>
        <option value="38400">38400</option>
        <option value="57600">57600</option>
        <option value="115200">115200</option>
      </InputSelect>
    </div>

    <div class="col-3">
      <label class="form-label fw-bold">Data bits</label>
      <InputSelect @bind-Value="_options.DataBits" class="form-select">
        <option value="5">5</option>
        <option value="6">6</option>
        <option value="7">7</option>
        <option value="8">8</option>
      </InputSelect>
    </div>

    <div class="col-3">
      <label class="form-label fw-bold">Parity</label>
      <InputSelect @bind-Value="_options.Parity" class="form-select">
        <option value="@Parity.None">None</option>
        <option value="@Parity.Odd">Odd</option>
        <option value="@Parity.Even">Even</option>
        <option value="@Parity.Mark">Mark</option>
        <option value="@Parity.Space">Space</option>
      </InputSelect>
    </div>

    <div class="col-3">
      <label class="form-label fw-bold">Stop bits</label>
      <InputSelect @bind-Value="_options.StopBits" class="form-select">
        <option value="@StopBits.One">1</option>
        <option value="@StopBits.OnePointFive">1.5</option>
        <option value="@StopBits.Two">2</option>
      </InputSelect>
    </div>
  </div>
</EditForm>

@code {

  private EditContext _editContext;
  private string[] _devices;
  private SerialPortOptions _options;

  [Parameter]
  public SerialPortOptions Options { get; set; }

  [Parameter]
  public EventCallback<SerialPortOptions> OptionsChanged { get; set; }


  protected override void OnInitialized()
  {
    _options = Options ?? new SerialPortOptions();
    _editContext = new EditContext(_options);
    _editContext.OnFieldChanged +=
      (_, _) => OptionsChanged.InvokeAsync(IsValid() ? _options : null);
  }

  protected override async Task OnInitializedAsync()
  {
    await LoadAvailableDevices();
  }

  private bool IsValid()
  {
    return _options.Device != string.Empty;
  }

  private async Task LoadAvailableDevices()
  {
    _devices = null;
    _devices = await SerialPortConnection.AvailableDevices();
  }

}
